/*
   Author:  James Tam
   Version: May 18, 2006

   Version 2 of the Sheep class now tracks information that is not specific to a
   particular sheep but relates to the whole herd (the size of the flock).  This
   information is tracked with the static/class variable "flockSize".

*/

public class Sheep
{
    private static int flockSize = 0;
    private String name;

    public Sheep ()
    {
        flockSize++;
        System.out.println("Creating \"No name\" sheep");
        name = "No name";
    }

    public Sheep (String aName)
    {
        flockSize++;
        System.out.println("Creating the sheep called " + aName);
        name = aName;
    }
    public static int getFlockSize () { return flockSize; }

    public String getName () {  return name; }

    public void setName (String newName) { name = newName; }

    public void finalize ()
    {
        System.out.print("Automatic garbage collector about to be called for ");
        System.out.println(this.name);
	  flockSize--;
    }
}// End of definition for class Sheep
